// *************************************************************************
//    Profile.h
// *************************************************************************

#ifndef _Profile_H_
#define _Profile_H_

#include <sys/time.h>
#include <sys/resource.h>
#include <time.h>    
#include <sys/timeb.h>    

#include "CoralStream.h"

// *************************************************************************

// This profile structure is associated with each rule.
class Cor_ProfileInfo {
  public:
    int i_newfacts;             // Set in do_rule()
    int i_unsuccesful;          // ditto
    int i_succesful;            // ditto

    int getnexts;               // Set in get_next_tuple()
    int non_unifying_tuples;    // ditto
    int deleted_tuples;         // ditto

    int unifies;                // Set in unify_args()
    int Cor_subsumes;           // Set in subsumes_args()

    int invocations;            // Count of number of rule invocations
    double usage_time;          // Total time used in processing this rule
    double usage_time_st;

    char *rule;                 // Contains the name of the current rule


    // Assigns the name string to this->rule
    inline void set_rule_name(char * name)  { rule = name;}

    // Prints the contents of the object preceded by the str
    void print(ostream *strm, char * str,int *predOrders = NULL,
        int numpreds = 0) const;
                                                    
    // Sets all object variablesto zero
    void clear();

    // Clears profile info
    void reset() {
        clear();
        rule=NULL;
    };

    // Constructor used for individual rule info variables. The 'name' string 
    // contains the rule in string form
    inline Cor_ProfileInfo(char *name) { clear(); rule = name; } 

    // Constructor used for GlobalProfileInfo, where no string is assigned to
    // this->name
    inline Cor_ProfileInfo() { clear(); rule = NULL; } 

    // Initializes for rule evaluation
    void init_rule();

    // Exits rule evaluation
    void exit_rule();
   ~Cor_ProfileInfo(){};
};


// *************************************************************************

extern Cor_ProfileInfo Cor_GlobalProfileInfo;

void Cor_AddProfileInfo(Cor_ProfileInfo *A, Cor_ProfileInfo *B);

// *************************************************************************

#endif _Profile_H_
