// *************************************************************************
//    QFPipelinedModuleData.h
// *************************************************************************

#ifndef _QFPipelinedModuleData_H_
#define _QFPipelinedModuleData_H_

#include "QFModuleData.h"

#include "PipelinedExecInfo.h"
#include "Predicate.h"
#include "BacktrackInfoArray.h"
#include "Stack.h"

// *************************************************************************
//    Codependent classes

class Cor_PipelinedExecInfo;

// *************************************************************************

struct pei_cache {
    Cor_PipelinedExecInfo *pei;
    char valid;
};

// *************************************************************************

class Cor_QFPipelinedModuleData : public Cor_QFModuleData {

  public:
    // Basically store the kind of information that a Scc stores
    Cor_Predicate **pred_ptrs;   // Array of preds corresponding to the module
    int    numPreds;             // Number of Preds used in the module
    int  **indices;              // set of indices for each predicate
    int   *maxNumVars;           // used for pre-allocation of BindEnv
    int   *maxNumLiterals;       // used for pre-allocation of StackMarks and 
                                 //        tuple-iterators

    int TableSetUp;

    Cor_BacktrackInfoArray backtrackInfo;
    struct pei_cache *pei_list;

    Cor_QFPipelinedModuleData(Cor_Table *, Cor_RuleInfoArray *,
                Cor_ParserStruct*);
   ~Cor_QFPipelinedModuleData();
    
    void clean_cache();
    virtual void Solve(Cor_Table *F, Cor_TupleIterator *) { this->F = F; }
    virtual ModuleKind kindof() { return COR_PIPELINED; }
};

// *************************************************************************

#endif _QFPipelinedModuleData_H_
