// *************************************************************************
//    SetSolvers.h
// *************************************************************************

#ifndef _SetSolvers_H_
#define _SetSolvers_H_

// *************************************************************************

#include "CoralError.h"

class Cor_BuiltinRelation;
class Cor_TupleIterator;
class Cor_BindEnv;
class Cor_Tuple;

// *************************************************************************

Cor_Tuple   *Cor_CreateSetSolver(Cor_Tuple *query);
Cor_Tuple   *Cor_AddElemDSolver(Cor_Tuple *query);
Cor_Tuple   *Cor_AddElemSolver(Cor_Tuple *query);

Cor_BindEnv *Cor_MemberSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_MemTupleSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_MultiUnionSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_UnionSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_IntersectionSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_DiffSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_SubsetSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_MakeSetSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_UnionDSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_MultiUnionDSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_IntersectionDSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_DiffDSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_MakeSetDSolver(Cor_TupleIterator& iterator);

// *************************************************************************

#endif _SetSolvers_H_
