#ifdef SOCK_REL

// *************************************************************************
//    SockRelation.h
// *************************************************************************

#ifndef _SockRelation_H_
#define _SockRelation_H_

#include "StorageRelation.h"
#include "RelationList.h"
#include "Debug.h"
#include "Config.h"
#include "CoralStream.h"
#include "SockStream.h"

#define MAX_WSNAME_LEN 100
#define MAX_HOSTNAME_LEN 100

class Cor_SockRelation : public Cor_StorageRelation {
private:
    char _local_name[COR_MAX_REL_NAME_LEN];
    int _arity;
    char _host[MAX_HOSTNAME_LEN];
    int _port;
    char _work_space[MAX_WSNAME_LEN];
    char _relation_name[COR_MAX_REL_NAME_LEN];

    int valid;
    CoralStream *cs;
    int sync_cnt;
    char PassWord[12];
    char Prompt[100];
    char Buf[2000];
    
    void ReceiveResponse();
    Cor_Tuple *GetNext();
    
    void Cor_SockRelation::Init(Cor_TupleIterator& iterator);
    Cor_Tuple *Cor_SockRelation::Done(Cor_TupleIterator& iterator);
    
public:

    Cor_SockRelation(char *ln, int arity, char *host, int port,
            char *ws, char *rn);
    
    ~Cor_SockRelation();

    int Valid() {return valid;}
    
    virtual int insert_tuple(Cor_Tuple *tuple);
    
    virtual Cor_BindEnv *get_next(Cor_TupleIterator&); 
    virtual Cor_Tuple *get_next_tuple( Cor_TupleIterator& it) ;

    virtual void release(Cor_TupleIterator& it) ;

    // Empty tuples out of the relation.  Delete the tuples
    // only if the deleteTuples arg is not 0
    virtual void empty_relation(int deleteTuples = 0);

    virtual int tuple_delete(Cor_Tuple *tuple);
    
    virtual void print_name(ostream *out);

};

// *************************************************************************

#endif _SockRelation_H_

#endif // SOCK_REL
