// *************************************************************************
//    Unparse.h
// *************************************************************************

#ifndef _Unparse_H_
#define _Unparse_H_

#include "BitVector.h"
#include "Rule.h"
#include "Sips.h"
#include "PredAnnotations.h"
#include "ModuleInfo.h"

// *************************************************************************

#define allargsfree(b) ( (b)->next(-1) < 0 )

// *************************************************************************

void Cor_print_rule(Cor_Clause *rule, ostream *out);
void Cor_sprint_rule(Cor_Clause *rule, char *str);

void Cor_print_rule_with_order(Cor_Clause *rule, int *predOrders,
        int *markOffsets, int recursive, ostream *out);

void Cor_print_pred( Cor_Literal *p, ostream *out, int head=0);

void Cor_print_adornment_brack(Cor_BitVector& a, ostream *file);

void Cor_print_sip(Cor_Clause *r, Cor_Sip *s, ostream *out);
void Cor_print_sips(Cor_Clause *r, Cor_Sips *s, ostream *out);

void sprint_adornment(char *buf, Cor_BitVector *adorn);
void sprint_adornment(char *buf, char *a);
void Cor_print_adornment(Cor_BitVector& a, ostream *file);
void Cor_print_adornment(Cor_BitVector *a, ostream *file);
void Cor_print_adornment(char *a, ostream *file);

void Cor_sprint_magic_name(char *buf, char *name, Cor_BitVector *adorn);
void Cor_sprint_magic_name(char *buf, char *name, char *adorn);
void Cor_fprint_magic_name(ostream *out, char *name, Cor_BitVector *adorn);
void Cor_fprint_magic_name(ostream *out, char *name, char *adorn);

void Cor_sprint_pred_name(char *buf, char *name, Cor_BitVector *adorn);
void Cor_sprint_pred_name(char *buf, char *name, char *adorn);
void Cor_fprint_pred_name(ostream *out, char *name, Cor_BitVector *adorn);
void Cor_fprint_pred_name(ostream *out, char *name, char *adorn);

void Cor_print_allowed_adornment_annotations(Cor_PredAnnotations *anno,
        ostream *file);
void Cor_print_aggsel_annotations(Cor_PredAnnotations *agg_sel, ostream *file);
void Cor_print_general_annotations(Cor_PredAnnotations *anno, 
        Cor_CArg *AnnoName, ostream *file);

void Cor_print_MultisetAnnotations(Cor_PredAnnotations *anno, ostream *file);
void Cor_print_Annotations(Cor_ModuleInfo& module_info, ostream *file,
    Cor_PredAnnotations *index, Cor_PredAnnotations *agg_sel,
    Cor_PredAnnotations *allowed_adorn, Cor_PredAnnotations *multiset,
    Cor_PredAnnotations *diskrel, Cor_PredAnnotations *asyncrel);

// *************************************************************************

#endif _Unparse_H_
