#include <strstream.h>
#include "RdbDelete.h"
#include "Log.h"


RdbDelete::RdbDelete(const RdbRelation& newRel, const BitVector& newAdorn)
: RdbCompilableDML(newRel.Database()),
  rel(newRel),
  adorn(newAdorn)
{  
}


void RdbDelete::CreateStmt(const String varPlaceHolder,
			   const int addSequence)
{
    ostrstream s;
    s << "delete from " << rel.RelName();
    int i;
    int setBit;
    for(setBit = adorn.next(-1), i = 0 ;
	setBit >= 0 ;
	setBit = adorn.next(setBit), i++ ) {
	if( i == 0 ) s << " where ";
	else         s << " and ";
	s << rel.ColName(setBit) << " = " << varPlaceHolder;
	if( addSequence ) s << i;
    }
    statement = s;
    RDBLOG(database.DBLog(), "Delete stmt: "<<statement<<'\n');
}


void RdbDelete::CreateStmt(const RdbItemList& bindings)
{
    ostrstream s;
    s << "delete from " << rel.RelName();
    int setBit;
    int i;
    for(setBit = adorn.next(-1), i = 0 ;
	setBit >= 0 ;
	setBit = adorn.next(setBit), i++ ) {
	if( i == 0 ) s << " where ";
	else         s << " and ";
	s << rel.ColName(setBit);
	switch( bindings[i].Type() ) {
	  case RdbItem::RDB_STRING:
	    s << " = " << '\'' << bindings[i] << '\'';
	    break;
	  case RdbItem::RDB_INT:
	  case RdbItem::RDB_REAL:
	    s << " = " << bindings[i];
	    break;
	  case RdbItem::RDB_NULL:
	    s << " is null";
	    break;
	  default:
	    assert(0);
	}
    }
    statement = s;
    RDBLOG(database.DBLog(), "Delete stmt: "<<statement<<'\n');
}


RdbError::ErrorCode RdbDelete::Delete(const RdbItemList& bindings)
{
    database.SetFocus();
    return VDelete(bindings);
}

