#ifndef _RDBSYBASEQUERY_H_
#define _RDBSYBASEQUERY_H_

#include "RdbQuery.h"
#include "RdbJoin.h"
#include "BitVector.h"

// forward delcarations:
class RdbSybaseSystem;
class RdbSybaseDatabase;


class RdbSybaseQuery
: public RdbQuery
{
  public:

    RdbSybaseQuery(const RdbJoin& newJoin, const BitVector& newAdorn);
				// create an sybase query on this join
				// with this expected adornment

    ~RdbSybaseQuery();

    RdbSybaseSystem& System();

    void const* Implementor() const;

  private:

    typedef List<String> StringList;

    RdbSybaseDatabase& database;

    ErrorCode CreateProcedure(); // creates a stored procedure for the
				 // select statement
    
    ErrorCode GetTypes(StringList& types);
				// creates a list of types for the
				// statement.

    virtual ErrorCode VOpen( RdbCursor& cursor );
				// open cursor on this query

    virtual ErrorCode VClose( RdbCursor& cursor );
				// close cursor 

    virtual ErrorCode VGetNext( RdbCursor& cursor, RdbItemList& result );
				// get the next item from the cursor
				// storing answer in result

    RdbSybaseQuery(const RdbSybaseQuery&); // na

    RdbSybaseQuery& operator =(const RdbSybaseQuery&); // na
};


#include "RdbSybaseQuery.i"

#endif // _RDBSYBASEQUERY_H_
