// *************************************************************************
//    PNode.h
//
//    Shaun Flisakowski - Feb 1996
// *************************************************************************

#ifndef _PNode_H_
#define _PNode_H_

#error "This include file is not being used yet."

// *************************************************************************

class Cor_PNode;
class Cor_PNodeChunk;

// *************************************************************************
class Cor_PNodeManager {

  private:
    Cor_PNodeChunk *_head;    // A list of PNodeChunk structs

  public:

    Cor_PNodeManager();
   ~Cor_PNodeManager();

};

// *************************************************************************
// This class holds pointers to all The parse nodes generated while
// parsing, the parse nodes can then still be deleted, even if the compile
// is interupted by a parse error.
// *************************************************************************

#define    PNODE_ARRY_SZE    512

class Cor_PNodeChunk {

  friend class Cor_PNode;

  private:
    Cor_PNode   *_store[PNODE_ARRY_SZE];  // The saved pointers
    int          _nxt_free;               // A likely spot to be free

    Cor_PNodeChunk  *_next;               // In case we run out of room.
                                          // We can make a linked list 
  public:
    Cor_PNodeChunk();
   ~Cor_PNodeChunk();
};

class Cor_PNode {

  friend class Cor_PNodeChunk;

  private:

    pnode_t     _type;

    Cor_CArg   *_carg;

    Cor_PNode  *_left;
    Cor_PNode  *_center;
    Cor_PNode  *_right;

    Cor_PNode();    // These are private to insure we get registered
   ~Cor_PNode();

  public:
      // Like a constructor, but registers the node with this PNodeChunk
    Cor_PNode *getPNode(Cor_PNodeChunk *nstore);
};

// *************************************************************************

#endif _PNode_H_
