// *************************************************************************
//    Annotations.h
// *************************************************************************

#ifndef _Annotations_H_
#define _Annotations_H_

#include "ArgList.h"
#include "BitVector.h"
#include "CArg.h"
#include "AggSelInfo.h"

// *************************************************************************

class Cor_PredAnnotations;
class Cor_ParserStruct;

// *************************************************************************

class Cor_AliasList {
  public:
};

// *************************************************************************

class Cor_RuleAnno {
  public:
    Cor_RuleAnno *next;
};

// *************************************************************************

class Cor_RuleAnnoCase {
  public:
    Cor_RuleAnnoCase *next;
};

// *************************************************************************

class Cor_RuleAnnoCaseDetails{
  public:

};

// *************************************************************************

class Cor_RuleAnnoCaseName{
  public:
};

// *************************************************************************

class Cor_RuleAnnotes {
  public:
};

// *************************************************************************

    // Quick little functions to convert an adornment into a BitVector
Cor_BitVector *Cor_create_adornment(char *adorn);
Cor_BitVector *Cor_create_adornment(Cor_CArg& adorn);

int Cor_duplicate_index(Cor_PredAnnotations *annos, Cor_CArg *pred,
    Cor_BitVector *bv,Cor_ArgList *al1, int num_vars, Cor_ArgList *al2);

int  Cor_add_make_index_annotation(Cor_PredAnnotations *& annos, Cor_CArg& p,
    Cor_CArg& a, Cor_ArgList *al1, Cor_ArgList *al2);

int  Cor_add_make_index_annotation(Cor_PredAnnotations *& annos, Cor_CArg *cp,
    Cor_CArg *ca, Cor_ArgList *a1, Cor_ArgList *a2);

int  Cor_add_make_index_annotation(Cor_PredAnnotations*& annos, Cor_CArg& p,
    Cor_BitVector *bv, Cor_ArgList *al1, Cor_ArgList *al2);


void Cor_add_agg_sel_annotation(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg *pred, Cor_CArg *adorn_string, Cor_ArgList *al1,
    Cor_ArgList *al2, Cor_CArg *op_arg, AggSelType agg_type=AggSel_Regular);

void Cor_add_allowed_adornment(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg *pred_name, Cor_ArgList *args);

void Cor_add_allowed_adornment(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg& pred_name, char *adorn_string, int adorn_length);

void Cor_add_disallowed_adornment(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg *pred_name, Cor_ArgList *args);

void Cor_add_disallowed_adornment(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg& pred_name, char *adorn_string, int adorn_length);

void Cor_add_multiset_annotation(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg *pred, Cor_ArgList *al1, int check_subsum);

void Cor_add_diskrel_annotation(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg *pred, Cor_CArg *adorn_string, Cor_ArgList *al1);

void Cor_add_asyncrel_annotation(Cor_ParserStruct *Cor_parserStruct,
    Cor_CArg *pred, Cor_ArgList *al1);

void Cor_update_anno_list(Cor_CArg& name, Cor_BitVector &adorn,
    Cor_PredAnnotations *anno);

void Cor_update_annotations(Cor_CArg& name, Cor_BitVector& adorn);

void Cor_annotation_error(Cor_PredAnnotations *anno, char *msg);

void Cor_add_index_delta_annotation(Cor_ParserStruct*, Cor_CArg*, Cor_ArgList*);
void Cor_add_index_delta_annotation();

Cor_RuleAnnoCaseDetails *Cor_make_anno_case_details(Cor_CArg *);
Cor_RuleAnnoCaseDetails *Cor_make_anno_case_details(Cor_RuleAnnoCase *);

Cor_RuleAnnoCaseName *Cor_make_anno_case_name(Cor_CArg *);

Cor_RuleAnnoCase *Cor_link_anno_case_list(Cor_RuleAnnoCase*, Cor_RuleAnnoCase*);

Cor_RuleAnno *Cor_link_rule_anno(Cor_RuleAnno*, Cor_RuleAnno*);

Cor_RuleAnnoCase *Cor_make_anno_case(Cor_RuleAnnoCaseName*,
    Cor_RuleAnnoCaseDetails*);

Cor_RuleAnno *Cor_make_anno(Cor_CArg*, Cor_RuleAnnoCaseDetails*);

// *************************************************************************

#endif _Annotations_H_
