// *************************************************************************
//    ExportInfo.h
// *************************************************************************

#ifndef _ExportInfo_H_
#define _ExportInfo_H_

#include "BitVector.h"
#include "Predicate.h"

// *************************************************************************
// An ExportInfo holds compile-time information about an
// exported predicate-adornment pair.

class  Cor_ExportInfo {

  public:
    Cor_ExportInfo      *next;
    Cor_CArg             pred_name;
    Cor_CArg             adorn_symbol;
    int                  sequence;     // Global sequence number.
    Cor_BitVector       *adornment;
    Cor_Predicate       *predicate;

    Cor_ExportInfo() {
        next      = NULL;
        adornment = NULL;
        predicate = NULL;
    }

   ~Cor_ExportInfo() {
        delete adornment;
    }
};

// *************************************************************************

#endif _ExportInfo_H_
