// *************************************************************************
//    PredAnnotations.h
// *************************************************************************

#ifndef _PredAnnotations_H_
#define _PredAnnotations_H_

#include "ArgList.h"
#include "BitVector.h"
#include "AggSelInfo.h"

// *************************************************************************

class Cor_PredAnnotations {

    Cor_PredAnnotations *_next;

  public:
    Cor_CArg       pred;
    Cor_ArgList   *arglist1;
    Cor_ArgList   *arglist2;
    Cor_BitVector *adorn;
    AggSelType     agg_type;
    Cor_CArg       op_arg;    // Operation and arg for aggregate selections
    int            check_subsum;

    Cor_PredAnnotations(Cor_CArg& pred1, Cor_PredAnnotations *next1);
   ~Cor_PredAnnotations();


    Cor_PredAnnotations *next()   { return _next;}
    Cor_PredAnnotations *link(Cor_PredAnnotations *tail) {
        _next = tail;
        return this;
    }

    void print(ostream *file, int adorned = 1); 

      // To conviently delete a list of these things
    void delete_list();
};

// *************************************************************************

#endif _PredAnnotations_H_
