// *************************************************************************
//    RuleInfoArray.C
// *************************************************************************

#include "RuleInfoArray.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
Cor_RuleInfoArray::Cor_RuleInfoArray()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    array_size = 0;
    numRules = 0 ;
    rInfoPtrs = NULL;
}

// *************************************************************************
Cor_RuleInfoArray::~Cor_RuleInfoArray()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    for (int i=0; i<numRules; i++)
        delete rInfoPtrs[i];
    
    delete [] rInfoPtrs;
}

// *************************************************************************
void Cor_RuleInfoArray::AddRule(Cor_RuleInfo *rInfo)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
        // Check if array needs expansion
    if (numRules == array_size){

        if (array_size == 0){
            array_size = MIN_RIARRAY_SIZE;
            rInfoPtrs = new (Cor_RuleInfo *)[array_size];
        } else {
                // Out of space - so double it
            Cor_RuleInfo **temp = rInfoPtrs;
            array_size += array_size;
            rInfoPtrs = new (Cor_RuleInfo *)[array_size];
            
            for (int i=0; i < numRules; i++)
                rInfoPtrs[i] = temp[i] ;

            delete [] temp;
        }
    }

    rInfoPtrs[numRules++] = rInfo;
}

// *************************************************************************
void Cor_RuleInfoArray::printon(ostream *out)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
#ifdef    DO_PROFILE
    for (int i=0; i< numRules; i++)
        *out <<  rInfoPtrs[i]->pInfo.rule << endl;
#endif
}

// *************************************************************************

