// *************************************************************************
//    Scc.C
// *************************************************************************

#include "Predicate.h"
#include "Unparse.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
void Cor_Scc::print(ostream *fd, int print_preds, int print_rules)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
  Cor_Predicate *p_list;
  int ruleno = 0;
  Cor_Clause *clause;

  if (print_preds) {
    *fd <<"  predicates: ";

    // print all predicate name in the Scc
    p_list = preds;
    while (p_list != NULL) 
      { 
    *fd << p_list->name.symbol();
    if (p_list->ext_magic)
      *fd << "(ext_magic)";
    p_list = p_list->next;
    if (p_list != NULL)
      *fd << ", ";
      }
    *fd << endl;
  }
  
  if (print_rules) {
    p_list = preds;
    while (p_list != NULL) { 
        for (clause = p_list->clauses; clause; clause = clause->pnext) {
           *fd << "  rule #" << ruleno++ << ": " << *clause;
        }
        p_list = p_list->next;
    }
  } 
}
      
// *************************************************************************
