// *************************************************************************
//    Solvers.h
// *************************************************************************

#ifndef _Solvers_H_
#define _Solvers_H_

// *************************************************************************

#include "CoralError.h"

class Cor_BuiltinRelation;
class Cor_TupleIterator;
class Cor_BindEnv;
class Cor_Tuple;

// *************************************************************************

    // Some internal solvers
Cor_BindEnv *Cor_InsertFactSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_DeleteFactSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_addIndexSolver1(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_addIndexSolver2(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_CutSolver(Cor_BuiltinRelation&, Cor_TupleIterator& iterator);

    // Some helpful builtins
Cor_BindEnv *Cor_AliasSolver(Cor_BuiltinRelation&, Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_CoralRootSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_HelpSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_HistorySolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_DisplayDefaultsSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_ResetDefaultsSolver(Cor_BuiltinRelation&,
                Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_QuitSolver(Cor_BuiltinRelation&, Cor_TupleIterator& iterator);

    // Meta-predicate solvers
Cor_BindEnv *Cor_UnivSolver(Cor_BuiltinRelation&, Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_ArgsSolver(Cor_BuiltinRelation&, Cor_TupleIterator& iterator);
Cor_BindEnv *Cor_CallSolver(Cor_TupleIterator& iterator);
Cor_BindEnv *ArgTypeSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);

    // A few extra math solvers
Cor_Tuple   *Cor_PowSolver(Cor_Tuple *in);
Cor_Tuple   *Cor_AbsSolver(Cor_Tuple *query);
Cor_Tuple   *Cor_CeilSolver(Cor_Tuple *query);
Cor_Tuple   *Cor_FloorSolver(Cor_Tuple *query);

    // String handling solvers
Cor_Tuple   *Cor_ExtractSolver(Cor_Tuple *query);
Cor_Tuple   *Cor_LengthSolver(Cor_Tuple *query);
Cor_Tuple   *Cor_SubstringSolver(Cor_Tuple *query);


    // This is for BuiltinTraceRelation
Cor_BindEnv *Cor_RelOptionsSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_SortRelSolver(Cor_BuiltinRelation& rel,
                Cor_TupleIterator& iterator);

// *************************************************************************

#endif _Solvers_H_
