/*****************************************************************************/
//    MyString.C
/*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "MyString.h"
#include "Main.h"

/*****************************************************************************/
void fatal_error(char *s)
{
    fprintf(error_file, "%s \n", s);
    exit(1);
}

/*****************************************************************************/
mystring::mystring()
{
    max = 256;
    pos = 0;
    buf = new (char[max]);
    if (buf == NULL)
        fatal_error("new failed in mystring constructor\n");
    buf[0] = '\0';
}

/*****************************************************************************/
void mystring::append(char *str)
{
    if (str == NULL)
        return;

    int len = strlen(str);
    if ((pos + len) >= max) {
        char *new_buf = new (char [max * 2]);

        if (new_buf == NULL)
            fatal_error ("new failed in mystring append\n");
        strncpy (new_buf, buf, pos+1);
        delete(buf);
        buf = new_buf;
        max *= 2;
    }
    strncpy(buf+pos, str, len);
    pos += len;
    buf[pos] = '\0';
}

/*****************************************************************************/
void mystring::print(FILE *output_file)
{    
    if (output_file)
        fprintf(output_file, "%s", buf);
    else 
        fprintf(stderr, "something fishy in mystring print fn\n");
}

/*****************************************************************************/
mystring::~mystring()
{
    delete(buf);
}

/*****************************************************************************/

